var wave = new paper.Path({
	strokeColor: [0.8],
	strokeWidth: 2,
	strokeCap: 'square'
});

var length = 40;

// Initialize waveform
for(var i = 0; i <= length; ++i)
{
	var ratio = i/length;
	var x = ratio * 80;
	var y = 0;
	wave.add(new paper.Point(x, y));
}

var box = new paper.Rectangle(new paper.Point(0, 0), new paper.Size(80, 80));
var boxBack = new paper.Rectangle(new paper.Point(0, 0), new paper.Size(80, 80));
var boxPath = new paper.Path.Rectangle(box, new paper.Size(10, 10));
var boxBackPath = new paper.Path.Rectangle(boxBack, new paper.Size(10, 10));

boxBackPath.fillColor = 'rgb(255, 255, 255)';
boxBackPath.opacity = 0.0;

boxPath.strokeColor = [0.8];
boxPath.strokeWidth = 8;

var group = new paper.Group([wave, boxPath, boxBackPath]);
var symbol = new paper.Symbol(group);

wave.onFrame = function(event) {
	for(var i = 0; i <= length; ++i)
	{
		var sinus = Math.sin(event.time*4 + 8*i/length);

		var point = this.segments[i].point;
		point.y = 0 + sinus * 20;
	}
};

var pushedElement = null;

var mouseDown = function (e) {
	pushedElement = e.target;
	//console.log(e.target);
};

var mouseMove = function (e) {

	if(pushedElement !== null)
	{
		var cx = e.clientX - canvas.offsetLeft;
		var cy = e.clientY - canvas.offsetTop;
		pushedElement.position = new paper.Point(cx, cy);

		var paper_id = pushedElement.id;
		var sm_id = getSoundId(paper_id);
		changePan(sm_id, getPan(cx));
	}

};

var mouseUp = function () {
	pushedElement = null;
};

function waveFunc (x) {
	return (40 + (20 * Math.sin(x * 3 * Math.PI)));
}

function placeWaveSymbol(x, y)
{
	var placed = symbol.place(new paper.Point(x, y));
	placed.onMouseDown = mouseDown;
	$(document).on('mousemove', mouseMove);
	placed.onMouseUp = mouseUp;
	return placed;
}