"use strict";

// Dependencies: SoundManager2 & jQuery
// bach

// Setup the soundManager instance

var sounds = [];
var html = "";
var dragSrcEl = null;
var canvas = document.getElementById("scope");
var ctx = canvas.getContext("2d");

// Holds key->value binding for soundManager id to corresponding symbol
var placed_symbols = {};

// Holds key->value binding for symbol id to corresponding soundManager id
var sounds_playing = {};

paper.setup(canvas);

ctx.fillStyle = "rgb(100, 100, 100)";
ctx.fillRect(0, 0, canvas.width, canvas.height);


soundManager.setup({
	// Fuck you, Flash.
	url: 'swf/',
	preferFlash: true,
	flashVersion: 9,
	debugMode: true,
	useHTML5Audio: false,
	debugFlash: true,
	onready: function() {
		createSoundObjects();
	}
});

soundManager.flash90options = {
	url			: 'swf/',
	usePeakData : true
};

soundManager.movieID = "sm-container";

// Load sounds from JSON and create sound objects
function createSoundObjects()
{
	var data = {};
	$.getJSON('json/sounds.json', function (data) { 
	
		$.each(data, function (key, val)
		{
			// Initialize soundmanager objects
			soundManager.createSound({
				id				: key,
				url				: '../sounds/' + val,
				stream			: true,
				multiShotEvents	: true,
				autoplay		: false,
				whileloading	: function () {
					/*console.log(this.id + ': loading '
						+ this.bytesLoaded + ' / '
						+ this.bytesTotal);*/
				},
				onload  		: function () {
					/*console.log(this.id + ' loaded');*/
				}, 
				
				whileplaying	: function () {

				}, 
				onfinish		: function () {

					/*console.log(this.id + " finished playing");*/

					document.getElementById(this.id).className = ""	;
					removeSound(this.id);

				},
				onstop			: function () {

				}
			});
	
			var humanString = key.split('_');
			humanString = humanString.join(" ");
			html += '<li id="' + key + '" draggable="true">'
			+ humanString + '</li>';
		});



	}).done(function () {
		$("ul#modules").html(html);
	
		var mods = $("ul#modules li");
		var canvas = $("div#canvas-wrap");

		mods.on('dragstart', handleDragStart);
		mods.on('mouseup', function (e) { startClipAtRandomPos(this.id); });
		canvas.on('dragover',  handleDragOver);
		canvas.on('dragleave', handleDragLeave);

		canvas.on('dragenter', handleDragEnter);
		canvas.on('drop', handleDrop);
	});
}


// Event handler for start of dragging modules
function handleDragStart(e)
{
	dragSrcEl = this;
	/*console.log("handleDragStart: " + dragSrcEl.id);*/
}

// Prevent default events, so we can drop it
function handleDragOver(e)
{
	if(e.preventDefault) 
	{
		e.preventDefault();
	}

	return false;
}

function handleDragEnter(e)
{

}

function handleDragLeave(e)
{

}

function removeSound(id)
{
	// Remove the image
	placed_symbols[id].remove();

	// Remove from objects
	var paper_id = placed_symbols[id].id;

	delete placed_symbols.paper_id;
	delete sounds_playing.id
}

function getPan(xpos)
{
	var width = canvas.width;
	var temp = ((2 * xpos) - width) / width;
	var pan = temp * 100;
	return pan;
}

function getSoundId(paper_id)
{
	return sounds_playing[paper_id];
}

function changePan(id, pan)
{
	var sound = soundManager.getSoundById(id);
	sound.setPan(pan);
}

function startClip(id, cx, cy)
{
	var activeSoundId = id;
	var activeSound = soundManager.getSoundById(activeSoundId);

	$('#' + id).addClass("playing");

	// Reference to placed symbol in paper
	var placed = placeWaveSymbol(cx, cy);

	// Update object reference array
	placed_symbols[activeSoundId] = placed;
	sounds_playing[placed.id] = activeSoundId;
	
	// Initialize sound pan and play
	soundManager.setPan(activeSoundId, getPan(cx));
	activeSound.play();
}

function startClipAtRandomPos(id)
{
	var cx = Math.floor(Math.random() * canvas.width);
	var cy = Math.floor(Math.random() * canvas.height);

	startClip(id, cx, cy);
}

function handleDrop(e)
{
	var cx = e.originalEvent.clientX - canvas.offsetLeft;
	var cy = e.originalEvent.clientY - canvas.offsetTop;

	startClip(dragSrcEl.id, cx, cy);

	if (e.stopPropagation)
	{
		e.stopPropagation();
	}

	return false;
}

$(document).ready(function (){

});